# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

* [`prometheus_node_exporter`](#prometheus_node_exporter): Puppet module to install and configure Prometheus Node Exporter

## Classes

### <a name="prometheus_node_exporter"></a>`prometheus_node_exporter`

Puppet module to install and configure Prometheus Node Exporter

#### Examples

##### 

```puppet
include prometheus_node_exporter
```

##### 

```puppet
class { 'prometheus_node_exporter':
  basic_auth_enabled => true,
}
```

#### Parameters

The following parameters are available in the `prometheus_node_exporter` class:

* [`basic_auth_enabled`](#-prometheus_node_exporter--basic_auth_enabled)
* [`basic_auth_hash_salt`](#-prometheus_node_exporter--basic_auth_hash_salt)
* [`basic_auth_hash_strength`](#-prometheus_node_exporter--basic_auth_hash_strength)
* [`basic_auth_password`](#-prometheus_node_exporter--basic_auth_password)
* [`basic_auth_username`](#-prometheus_node_exporter--basic_auth_username)
* [`binary_symlink`](#-prometheus_node_exporter--binary_symlink)
* [`extra_configuration_options`](#-prometheus_node_exporter--extra_configuration_options)
* [`manage_installation`](#-prometheus_node_exporter--manage_installation)
* [`manage_service_user`](#-prometheus_node_exporter--manage_service_user)
* [`manage_selinux_requirements`](#-prometheus_node_exporter--manage_selinux_requirements)
* [`manage_systemd_service`](#-prometheus_node_exporter--manage_systemd_service)
* [`service_enabled`](#-prometheus_node_exporter--service_enabled)
* [`service_ensure`](#-prometheus_node_exporter--service_ensure)
* [`service_group`](#-prometheus_node_exporter--service_group)
* [`service_username`](#-prometheus_node_exporter--service_username)
* [`source_archive_base`](#-prometheus_node_exporter--source_archive_base)
* [`systemd_service_file`](#-prometheus_node_exporter--systemd_service_file)
* [`systemd_service_name`](#-prometheus_node_exporter--systemd_service_name)
* [`target_folder_location`](#-prometheus_node_exporter--target_folder_location)
* [`tls_enabled`](#-prometheus_node_exporter--tls_enabled)
* [`tls_certificate_file`](#-prometheus_node_exporter--tls_certificate_file)
* [`tls_private_key_file`](#-prometheus_node_exporter--tls_private_key_file)
* [`tls_use_puppet_certificates`](#-prometheus_node_exporter--tls_use_puppet_certificates)
* [`version`](#-prometheus_node_exporter--version)
* [`web_configuration_folder`](#-prometheus_node_exporter--web_configuration_folder)
* [`web_configuration_file`](#-prometheus_node_exporter--web_configuration_file)
* [`web_listen_address`](#-prometheus_node_exporter--web_listen_address)

##### <a name="-prometheus_node_exporter--basic_auth_enabled"></a>`basic_auth_enabled`

Data type: `Boolean`

Determines if basic web authentication is used

Default value: `true`

##### <a name="-prometheus_node_exporter--basic_auth_hash_salt"></a>`basic_auth_hash_salt`

Data type: `Sensitive[String]`

Sets the hash salt for basic web based authentication. Exactly 22 characters, no symbols

Default value: `Sensitive('0123456789AbCdEfGhIjKl')`

##### <a name="-prometheus_node_exporter--basic_auth_hash_strength"></a>`basic_auth_hash_strength`

Data type: `String`

Strength of the hash, number represented as string between 4 and 31 inclusive

Default value: `'10'`

##### <a name="-prometheus_node_exporter--basic_auth_password"></a>`basic_auth_password`

Data type: `Sensitive[String]`

Sets the password for basic web based authentication

Default value: `Sensitive('<password>')`

##### <a name="-prometheus_node_exporter--basic_auth_username"></a>`basic_auth_username`

Data type: `String`

Sets the username for basic web based authentication

Default value: `'prometheus'`

##### <a name="-prometheus_node_exporter--binary_symlink"></a>`binary_symlink`

Data type: `String`

Location to symlink binary for execution

Default value: `'/usr/local/bin/node_exporter'`

##### <a name="-prometheus_node_exporter--extra_configuration_options"></a>`extra_configuration_options`

Data type: `Hash`

A hash of additional configuration items to add to the service start command.
Example:
{
  '--collector.textfile.directory' => '/var/lib/node_exporter/textfile/'
}

Default value: `{}`

##### <a name="-prometheus_node_exporter--manage_installation"></a>`manage_installation`

Data type: `Boolean`

Manage the installation from tarball sourc

Default value: `true`

##### <a name="-prometheus_node_exporter--manage_service_user"></a>`manage_service_user`

Data type: `Boolean`

Manage the local user to run the service as

Default value: `true`

##### <a name="-prometheus_node_exporter--manage_selinux_requirements"></a>`manage_selinux_requirements`

Data type: `Boolean`

Manage SE Linux to allow node exporter to run

Default value: `true`

##### <a name="-prometheus_node_exporter--manage_systemd_service"></a>`manage_systemd_service`

Data type: `Boolean`

Manage the configuration of the systemd service definition

Default value: `true`

##### <a name="-prometheus_node_exporter--service_enabled"></a>`service_enabled`

Data type: `Boolean`

Set if systemd service is enabled at boot time

Default value: `true`

##### <a name="-prometheus_node_exporter--service_ensure"></a>`service_ensure`

Data type: `String`

Value for systemd service configuration: running, stopped, etc.

Default value: `running`

##### <a name="-prometheus_node_exporter--service_group"></a>`service_group`

Data type: `String`

The local group to run the node_exporter service

Default value: `'node_exporter'`

##### <a name="-prometheus_node_exporter--service_username"></a>`service_username`

Data type: `String`

The local username to run the node_exporter service

Default value: `'node_exporter'`

##### <a name="-prometheus_node_exporter--source_archive_base"></a>`source_archive_base`

Data type: `String`

Base location for source archive

Default value: `'https://github.com/prometheus/node_exporter/releases/download'`

##### <a name="-prometheus_node_exporter--systemd_service_file"></a>`systemd_service_file`

Data type: `String`

File location for systemd service definition

Default value: `'/etc/systemd/system/node_exporter.service'`

##### <a name="-prometheus_node_exporter--systemd_service_name"></a>`systemd_service_name`

Data type: `String`

Service name for systemd service definition

Default value: `'node_exporter'`

##### <a name="-prometheus_node_exporter--target_folder_location"></a>`target_folder_location`

Data type: `String`

Location on filesystem to for archive extraction & program location

Default value: `'/opt'`

##### <a name="-prometheus_node_exporter--tls_enabled"></a>`tls_enabled`

Data type: `Boolean`

Determines whether to use TLS/SSL for web connections

Default value: `true`

##### <a name="-prometheus_node_exporter--tls_certificate_file"></a>`tls_certificate_file`

Data type: `String`

Location on filesystem of public certificate file for TLS communications

Default value: `'/etc/prometheus_node_exporter/tlsCertificate.crt'`

##### <a name="-prometheus_node_exporter--tls_private_key_file"></a>`tls_private_key_file`

Data type: `String`

Location on filesystem of private key file for TLS communications

Default value: `'/etc/prometheus_node_exporter/tlsCertificate.key'`

##### <a name="-prometheus_node_exporter--tls_use_puppet_certificates"></a>`tls_use_puppet_certificates`

Data type: `Boolean`

Determines whether to use the Puppet agent certificates for TLS
- If set true, will use Puppet agent certificate files for TLS
- If set false, will use $tls_certificate_file and $tls_private_key_file

Default value: `true`

##### <a name="-prometheus_node_exporter--version"></a>`version`

Data type: `String`

Version of Prometheus Node Exporter to download, install and configure

Default value: `'1.8.1'`

##### <a name="-prometheus_node_exporter--web_configuration_folder"></a>`web_configuration_folder`

Data type: `String`

Filesystem folder location for Node Exporter web configuration

Default value: `'/etc/prometheus_node_exporter'`

##### <a name="-prometheus_node_exporter--web_configuration_file"></a>`web_configuration_file`

Data type: `String`

Filename for the web configuration file in the web_configuration_folder

Default value: `'configuration.yml'`

##### <a name="-prometheus_node_exporter--web_listen_address"></a>`web_listen_address`

Data type: `String`

Address:port combination to bind on for web listener

Default value: `':9100'`

